## mingw-w64-gr-0.73.18-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18...4.0 FATAL_ERROR)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")
include(GetVersionFromGit)
get_version_from_git(GR_VERSION GR_VERSION_FULL)

project(
  GR
  VERSION ${GR_VERSION}
  LANGUAGES C CXX
)

include(GNUInstallDirs)
include(CheckCXXCompilerFlag)

check_cxx_compiler_flag("-Werror=implicit" ERROR_IMPLICIT_SUPPORTED)
if(ERROR_IMPLICIT_SUPPORTED)
  set(COMPILER_OPTION_ERROR_IMPLICIT
      "-Werror=implicit"
      CACHE INTERNAL "Compiler flag for generating errors on implicit declarations"
  )
else()
  set(COMPILER_OPTION_ERROR_IMPLICIT
      ""
      CACHE INTERNAL "Compiler flag for generating errors on implicit declarations"
  )
endif()

if(UNIX)
  if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX
        "/usr/local/gr"
        CACHE PATH "GR install prefix" FORCE
    )
  endif()
endif()
# Force to install libraries to `lib` (avoid `lib64` on RHEL distributions)
set(CMAKE_INSTALL_LIBDIR "lib")
set(GR_DIRECTORY
    "${CMAKE_INSTALL_PREFIX}"
    CACHE STRING "Default value for GRDIR"
)
option(GR_BUILD_DEMOS "Build demos for GR" OFF)
option(GR_BUILD_GKSM "Build GKS metafile reader for GR" OFF)
option(GR_INSTALL "Create installation target for GR" ON)
option(GR_USE_BUNDLED_LIBRARIES "Use thirdparty libraries bundled with GR" OFF)
option(GR_MANUAL_MOC_AND_RCC "Manually run moc and rcc instead of relying on AUTOMOC and AUTORCC" OFF)
option(GR_FIND_QT5_BY_VARIABLES "Find Qt5 based on the variables Qt5_INCLUDE_DIR and Qt5_LIBRARY_DIR" OFF)
option(GR_PREFER_XCODEBUILD "Prefer xcodebuild to build macOS applications if available" ON)

if(EMSCRIPTEN)
  set(GR_DIRECTORY
      "/"
      CACHE STRING "Emscripten requires `/` as GRDIR" FORCE
  )
  set(GR_INSTALL
      OFF
      CACHE BOOL "Install is not supported on Emscripten" FORCE
  )
  set(CMAKE_C_FLAGS_DEBUG
      "--no-heap-copy -g3 -O0 -s ASSERTIONS=2 -s SAFE_HEAP=0 -s STACK_OVERFLOW_CHECK=2 -sNO_DISABLE_EXCEPTION_CATCHING=1 -sWASM=0"
  )
  set(CMAKE_C_FLAGS_RELEASE "--no-heap-copy -O3 -DNDEBUG")
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG}")
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
endif()

if(GR_USE_BUNDLED_LIBRARIES)
  list(PREPEND CMAKE_FIND_ROOT_PATH "${CMAKE_CURRENT_LIST_DIR}/3rdparty/build/")
  set(GR_THIRDPARTY_LIBRARY_PREFIX ${CMAKE_STATIC_LIBRARY_PREFIX})
  set(GR_THIRDPARTY_LIBRARY_SUFFIX ${CMAKE_STATIC_LIBRARY_SUFFIX})
else()
  set(GR_THIRDPARTY_LIBRARY_PREFIX ${CMAKE_SHARED_LIBRARY_PREFIX})
  set(GR_THIRDPARTY_LIBRARY_SUFFIX ${CMAKE_SHARED_LIBRARY_SUFFIX})
endif()

if(GR_FIND_QT5_BY_VARIABLES)
  list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake/optional/qt5")
endif()

if(WIN32)
  set(GR_PLUGIN_SUFFIX ".dll")
else()
  set(GR_PLUGIN_SUFFIX ".so")
endif()

if(APPLE)
  set(DEFAULT_SHARED_LIBRARY_SUFFIX ".dylib")
else()
  set(DEFAULT_SHARED_LIBRARY_SUFFIX "${GR_PLUGIN_SUFFIX}")
endif()

set(GR_SHARED_LIBRARY_SUFFIX
    "${DEFAULT_SHARED_LIBRARY_SUFFIX}"
    CACHE STRING "File suffix for shared libraries"
)

set(CMAKE_FIND_PACKAGE_PREFER_CONFIG
    TRUE
    CACHE BOOL ""
)

# Find the following packages always in system locations even if `GR_USE_BUNDLED_LIBRARIES` is set, because they are not
# located in 3rdparty
if(NOT EMSCRIPTEN)
  find_package(X11)
  find_package(Fontconfig)
  find_package(OpenGL OPTIONAL_COMPONENTS OpenGL)
  if(${CMAKE_VERSION} VERSION_GREATER "3.16.0")
    find_package(
      Qt6
      OPTIONAL_COMPONENTS
        Widgets
        Core
        Network
        Gui
        PrintSupport
    )
  endif()
  find_package(
    Qt5
    OPTIONAL_COMPONENTS
      Widgets
      Core
      Network
      Gui
      PrintSupport
  )
  find_package(Qt4)
endif()

# Find the following packages only in 3rdparty, if `GR_USE_BUNDLED_LIBRARIES` is set
if(GR_USE_BUNDLED_LIBRARIES)
  set(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)
  set(CMAKE_FIND_ROOT_PATH_MODE_LIBRARY ONLY)
  set(CMAKE_FIND_ROOT_PATH_MODE_PACKAGE ONLY)
  set(CMAKE_FIND_ROOT_PATH_MODE_PROGRAM ONLY)
endif()
find_package(Freetype)
if(TARGET freetype AND NOT TARGET Freetype::Freetype)
  add_library(Freetype::Freetype ALIAS freetype)
endif()
find_package(Jpeg REQUIRED)
find_package(Libpng REQUIRED)
find_package(ZLIB REQUIRED)
find_package(Qhull REQUIRED)
if(TARGET Qhull::qhullstatic_r AND NOT TARGET Qhull::qhull_r)
  add_library(Qhull::qhull_r ALIAS Qhull::qhullstatic_r)
endif()
if(NOT EMSCRIPTEN)
  find_package(Tiff)
  if(TARGET TIFF::tiff AND NOT TARGET Tiff::Tiff)
    add_library(Tiff::Tiff ALIAS TIFF::tiff)
  endif()
  find_package(Ffmpeg 57.48.100)
  find_package(glfw3)
  if(TARGET glfw AND NOT TARGET Glfw::Glfw)
    add_library(Glfw::Glfw ALIAS glfw)
  endif()
  find_package(ZeroMQ)
  if(NOT TARGET ZeroMQ::ZeroMQ)
    if(TARGET libzmq)
      add_library(ZeroMQ::ZeroMQ ALIAS libzmq)
    elseif(TARGET libzmq-static)
      add_library(ZeroMQ::ZeroMQ ALIAS libzmq-static)
      get_target_property(ZeroMQ_LIBRARY libzmq-static LOCATION)
    endif()
  endif()
  find_package(Cairo)
  find_package(Agg)
  find_package(Gs)
endif()
find_package(XercesC)

if(APPLE)
  set(INSTALL_RPATH "${GR_DIRECTORY}/lib/;@loader_path/.")
else()
  set(INSTALL_RPATH "${GR_DIRECTORY}/lib/;$ORIGIN/.")
endif()

if(Qt4_FOUND
   OR (Qt5Widgets_FOUND
       AND Qt5Core_FOUND
       AND Qt5Network_FOUND
      )
   OR (Qt6Widgets_FOUND
       AND Qt6Core_FOUND
       AND Qt6Network_FOUND
      )
)
  if(GR_MANUAL_MOC_AND_RCC)
    if(NOT QT_MOC_EXECUTABLE)
      find_program(QT_MOC_EXECUTABLE moc CMAKE_FIND_ROOT_PATH_BOTH)
    endif()
    if(NOT QT_MOC_EXECUTABLE)
      message(FATAL_ERROR "Could not find moc but GR_MANUAL_MOC_AND_RCC is set.")
    endif()
    if(NOT QT_RCC_EXECUTABLE)
      find_program(QT_RCC_EXECUTABLE rcc CMAKE_FIND_ROOT_PATH_BOTH)
    endif()
    if(NOT QT_RCC_EXECUTABLE)
      message(FATAL_ERROR "Could not find rcc but GR_MANUAL_MOC_AND_RCC is set.")
    endif()
  endif()
endif()
if(Qt4_FOUND)
  set(QT4_MOC_INCLUDE_FLAGS "")
  foreach(DIR IN LISTS QT_INCLUDE_DIR)
    set(QT4_MOC_INCLUDE_FLAGS ${QT4_MOC_INCLUDE_FLAGS} -I${DIR})
  endforeach()
  if(NOT DEFINED Qt4_LIBRARY_DIR)
    get_filename_component(Qt4_LIBRARY_DIR "${QT_LIBRARY_DIR}/../.." ABSOLUTE)
  endif()
endif()
if(Qt5Widgets_FOUND
   AND Qt5Core_FOUND
   AND Qt5Network_FOUND
)
  set(QT5_MOC_INCLUDE_FLAGS "")
  foreach(DIR IN LISTS Qt5Core_INCLUDE_DIRS Qt5Gui_INCLUDE_DIRS Qt5Widgets_INCLUDE_DIRS)
    set(QT5_MOC_INCLUDE_FLAGS ${QT5_MOC_INCLUDE_FLAGS} -I${DIR})
  endforeach()
  if(NOT DEFINED Qt5_LIBRARY_DIR)
    get_filename_component(Qt5_LIBRARY_DIR "${Qt5_DIR}/../.." ABSOLUTE)
  endif()
endif()
if(Qt6Widgets_FOUND
   AND Qt6Core_FOUND
   AND Qt6Network_FOUND
)
  set(QT6_MOC_INCLUDE_FLAGS "")
  foreach(DIR IN LISTS Qt6Core_INCLUDE_DIRS Qt6Gui_INCLUDE_DIRS Qt6Widgets_INCLUDE_DIRS)
    set(QT6_MOC_INCLUDE_FLAGS ${QT6_MOC_INCLUDE_FLAGS} -I${DIR})
  endforeach()
  if(NOT DEFINED Qt6_LIBRARY_DIR)
    get_filename_component(Qt6_LIBRARY_DIR "${Qt6_DIR}/../.." ABSOLUTE)
  endif()
endif()

if(X11_FOUND)
  # older versions of FindX11.cmake set variables but do not create targets
  if(NOT TARGET X11::X11
     AND X11_INCLUDE_DIR
     AND X11_X11_LIB
     AND X11_Xft_LIB
  )
    add_library(X11::X11 UNKNOWN IMPORTED)
    set_target_properties(
      X11::X11
      PROPERTIES INTERFACE_INCLUDE_DIRECTORIES "${X11_INCLUDE_DIR}/"
                 IMPORTED_LINK_INTERFACE_LANGUAGES "C"
                 IMPORTED_LOCATION "${X11_X11_LIB}"
                 INTERFACE_LINK_LIBRARIES "${X11_Xft_LIB}"
    )
  endif()
  if(NOT TARGET X11::Xt
     AND X11_INCLUDE_DIR
     AND X11_Xt_LIB
     AND TARGET X11::X11
  )
    add_library(X11::Xt UNKNOWN IMPORTED)
    set_target_properties(
      X11::Xt
      PROPERTIES INTERFACE_INCLUDE_DIRECTORIES "${X11_INCLUDE_DIR}/"
                 IMPORTED_LINK_INTERFACE_LANGUAGES "C"
                 IMPORTED_LOCATION "${X11_Xt_LIB}"
                 INTERFACE_LINK_LIBRARIES "X11::X11"
    )
  endif()
endif()

set(GKS_SOURCES
    lib/gks/afm.c
    lib/gks/font.c
    lib/gks/socket.c
    lib/gks/ft.c
    lib/gks/malloc.c
    lib/gks/util.c
    lib/gks/compress.c
    lib/gks/gks.c
    lib/gks/mf.c
    lib/gks/win.c
    lib/gks/gksforbnd.c
    lib/gks/pdf.c
    lib/gks/wiss.c
    lib/gks/dl.c
    lib/gks/plugin.c
    lib/gks/error.c
    lib/gks/io.c
    lib/gks/ps.c
    lib/gks/resample.c
)
if(EMSCRIPTEN)
  list(APPEND GKS_SOURCES js/jsplugin.c)
  list(REMOVE_ITEM GKS_SOURCES lib/gks/compress.c)
  list(REMOVE_ITEM GKS_SOURCES lib/gks/dl.c)
  list(REMOVE_ITEM GKS_SOURCES lib/gks/gksforbnd.c)
  list(REMOVE_ITEM GKS_SOURCES lib/gks/mf.c)
  list(REMOVE_ITEM GKS_SOURCES lib/gks/pdf.c)
  list(REMOVE_ITEM GKS_SOURCES lib/gks/plugin.c)
  list(REMOVE_ITEM GKS_SOURCES lib/gks/ps.c)
  list(REMOVE_ITEM GKS_SOURCES lib/gks/resample.c)
  list(REMOVE_ITEM GKS_SOURCES lib/gks/socket.c)
  list(REMOVE_ITEM GKS_SOURCES lib/gks/win.c)
endif()

add_library(gks_static STATIC ${GKS_SOURCES})
list(APPEND GKS_LIBRARIES gks_static)
if(NOT EMSCRIPTEN)
  add_library(gks_shared SHARED ${GKS_SOURCES})
  list(APPEND GKS_LIBRARIES gks_shared)
endif()

foreach(LIBRARY IN LISTS GKS_LIBRARIES)
  if(LIBRARY MATCHES "static")
    set(GKS_LINK_MODE PUBLIC)
  else()
    set(GKS_LINK_MODE PRIVATE)
  endif()
  if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_definitions(${LIBRARY} PRIVATE _CRT_SECURE_NO_WARNINGS)
  endif()
  if(NOT ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC"))
    if(NOT EMSCRIPTEN)
      target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} pthread)
    endif()
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} m)
  endif()
  if(Freetype_FOUND)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} Freetype::Freetype)
  else()
    target_compile_definitions(
      ${LIBRARY}
      ${GKS_LINK_MODE}
      NO_FT
    )
  endif()
  target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} ZLIB::ZLIB)
  target_compile_definitions(
    ${LIBRARY}
    ${GKS_LINK_MODE}
    HAVE_ZLIB
  )
  if(UNIX)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} dl)
  elseif(WIN32)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} ws2_32)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} msimg32)
    target_link_libraries(${LIBRARY} ${GKS_LINK_MODE} gdi32)
  endif()
  if(NOT ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC"))
    if(NOT EMSCRIPTEN)
      target_compile_options(${LIBRARY} ${GKS_LINK_MODE} -pthread)
    endif()
  endif()
  target_compile_options(${LIBRARY} PRIVATE ${COMPILER_OPTION_ERROR_IMPLICIT})
  target_include_directories(
    ${LIBRARY} PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib/gks/>
                      $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  )
  target_compile_definitions(${LIBRARY} PRIVATE GRDIR="${GR_DIRECTORY}")
  set_target_properties(
    ${LIBRARY}
    PROPERTIES C_STANDARD 90
               C_EXTENSIONS OFF
               C_STANDARD_REQUIRED ON
               POSITION_INDEPENDENT_CODE ON
               PREFIX "lib"
               IMPORT_PREFIX "lib"
               OUTPUT_NAME GKS
               INSTALL_RPATH "${INSTALL_RPATH}"
  )
endforeach()
unset(GKS_LINK_MODE)
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
  set_target_properties(gks_static PROPERTIES OUTPUT_NAME GKSstatic)
endif()
if(NOT EMSCRIPTEN)
  set_target_properties(gks_shared PROPERTIES SUFFIX "${GR_SHARED_LIBRARY_SUFFIX}" EXPORT_NAME GKS)
endif()
add_library(GR::GKS ALIAS gks_static)
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/gr_version.h
     "#ifndef GR_VERSION\n#define GR_VERSION \"${GR_VERSION_FULL}\"\n#endif\n"
)
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/gr_version.h PROPERTIES GENERATED TRUE)

set(GR_SOURCES
    lib/gr/boundary.c
    lib/gr/contour.c
    lib/gr/contourf.c
    lib/gr/delaunay.c
    lib/gr/gr.c
    lib/gr/grforbnd.c
    lib/gr/gridit.c
    lib/gr/image.c
    lib/gr/import.c
    lib/gr/interp2.c
    lib/gr/stream.c
    lib/gr/md5.c
    lib/gr/shade.c
    lib/gr/spline.c
    lib/gr/strlib.c
    lib/gr/text.c
    lib/gr/mathtex2.c
    lib/gr/mathtex2_kerning.c

=== Makefile ===
BUILD_TYPE = Release
BUILD_DEMOS = OFF
EXPORT_COMPILE_COMMANDS = OFF
GRDIR = /usr/local/gr
UNAME := $(shell uname)
ifneq (,$(filter self,$(MAKECMDGOALS)))
  USE_BUNDLED_LIBRARIES = ON
else
  USE_BUNDLED_LIBRARIES = OFF
endif

PREFERRED_CLANG_FORMAT_VERSION="13"
ifeq ($(shell command -v "clang-format-$(PREFERRED_CLANG_FORMAT_VERSION)"),)
  CLANG_FORMAT="clang-format"
else
  CLANG_FORMAT="clang-format-$(PREFERRED_CLANG_FORMAT_VERSION)"
endif

default: all

all: build

pre-check:
	@lib/Precheck "${GRDIR}"  || \
	( echo "FATAL: Source and target directory are identical"; exit 1 )

configure: pre-check $(subst ON,bundled-libraries,$(filter ON,$(USE_BUNDLED_LIBRARIES)))
	cmake \
	  -DCMAKE_INSTALL_PREFIX="$(GRDIR)" \
	  -DCMAKE_BUILD_TYPE="$(BUILD_TYPE)" \
	  -DGR_BUILD_DEMOS="$(BUILD_DEMOS)" \
	  -DGR_USE_BUNDLED_LIBRARIES="$(USE_BUNDLED_LIBRARIES)" \
	  -DCMAKE_EXPORT_COMPILE_COMMANDS="$(EXPORT_COMPILE_COMMANDS)" \
	  -S . \
	  -B build

build:
	@if [ ! -d build ]; then \
	  $(MAKE) configure \
	    GRDIR="$(GRDIR)" \
	    BUILD_TYPE="$(BUILD_TYPE)" \
	    BUILD_DEMOS="$(BUILD_DEMOS)" \
	    USE_BUNDLED_LIBRARIES="$(USE_BUNDLED_LIBRARIES)" \
	    EXPORT_COMPILE_COMMANDS="$(EXPORT_COMPILE_COMMANDS)"; \
	fi
	cmake --build build -j

install:
	@if [ ! -d build ]; then \
	  $(MAKE) build \
	    GRDIR="$(GRDIR)" \
	    BUILD_TYPE="$(BUILD_TYPE)" \
	    BUILD_DEMOS="$(BUILD_DEMOS)" \
	    USE_BUNDLED_LIBRARIES="$(USE_BUNDLED_LIBRARIES)" \
	    EXPORT_COMPILE_COMMANDS="$(EXPORT_COMPILE_COMMANDS)"; \
	fi
	cmake --install build

clean:
	rm -rf build
	$(MAKE) -C 3rdparty clean
	rm -f gr.pkg

realclean: clean
	$(MAKE) -C 3rdparty realclean
	find packaging -type f \( -name '*.deb' -o -name '*.rpm' \) -exec rm \{\} \;
	rm -rf tmp

bundled-libraries:
	$(MAKE) -C 3rdparty default extras

self: build

osxpkg:
	mkdir -p tmp/bin tmp/gr
	rsync -a /usr/local/gr/ tmp/gr/
	ln -s ../gr/bin/gr tmp/bin/gr
	ln -s ../gr/Applications/glgr.app/Contents/MacOS/glgr tmp/bin/glgr
	ln -s ../gr/Applications/gksqt.app/Contents/MacOS/gksqt tmp/bin/gksqt
	@if [ -e ../gr/Applications/grplot.app/Contents/MacOS/grplot ]; then \
	ln -s ../gr/Applications/grplot.app/Contents/MacOS/grplot tmp/bin/grplot; fi
	sudo chown -R -h root:wheel tmp/
	pkgbuild --identifier de.fz-juelich.gr --root tmp --install-location /usr/local --ownership preserve gr.pkg
	sudo rm -rf tmp

code-format:
ifeq ($(UNAME), Darwin)
	@find -E . -type f \
	           -regex '.*\.(c|cpp|cxx|m|h|hpp|hxx)' \
	         ! -path './3rdparty/*' \
	         ! -path './apps/*' \
	         ! -path './build/*' \
	           -exec "$(CLANG_FORMAT)" -i -verbose -style=file {} \;
	@CMAKE_FORMAT="$$(./.setup_cmakeformat.sh)" && \
	find -E . -type f \
	          -regex '(.*/CMakeLists\.txt)|(.*\.cmake)' \
	        ! -path './3rdparty/*' \
	        ! -path './apps/*' \
	        ! -path './build/*' \
	          -exec echo "Formatting "{} \; \
	          -exec "$${CMAKE_FORMAT}" -i {} \;
else
	@find . -type f \
	        -regextype posix-extended \
	        -regex '.*\.(c|cpp|cxx|m|h|hpp|hxx)' \
	      ! -path './3rdparty/*' \
	      ! -path './apps/*' \
	      ! -path './build/*' \
	        -exec "$(CLANG_FORMAT)" -i -verbose -style=file {} \;
	@CMAKE_FORMAT="$$(./.setup_cmakeformat.sh)" && \
	find . -type f \
	       -regextype posix-extended \
	       -regex '(.*/CMakeLists\.txt)|(.*\.cmake)' \
	     ! -path './3rdparty/*' \
	     ! -path './apps/*' \
	     ! -path './build/*' \
	       -exec echo "Formatting "{} \; \
	       -exec "$${CMAKE_FORMAT}" -i {} \;
endif


.PHONY: default all pre-check configure build install clean realclean bundled-libraries self osxpkg code-format

=== 3rdparty/Makefile ===
UNAME := $(shell uname)

 TARGETS = freetype jpeg libpng16 zlib qhull bzip2
ifeq ($(UNAME), Darwin)
 TARGETS += zeromq
endif
  EXTRAS = agg tiff ogg theora vpx openh264 ffmpeg glfw zeromq pixman cairo icu xerces-c
     DIR =

EXTRACLEAN = agg icu xerces-c zeromq

default:
	@set -e; for d in $(TARGETS); do $(MAKE) -C $$d PREFIX=$(DIR); done

extras:
	@set -e; for d in $(EXTRAS); do $(MAKE) -C $$d PREFIX=$(DIR); done

clean:
	@set -e; for d in $(TARGETS) $(EXTRACLEAN); do $(MAKE) -C $$d clean; done

realclean: clean
	rm -rf ./build

.PHONY: default extras clean realclean

=== 3rdparty/agg/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

 CXXFLAGS = -Wall -pedantic -O -Iinclude -std=c++11 -fPIC -fno-common $(ARCHS)
ifndef OS
ifeq ($(shell uname),Darwin)
CXXFLAGS += -mmacosx-version-min=10.11
endif
else ifeq ($(shell [[ "$(OS)" =~ [dD]"arwin" ]] && echo macos), macos)
CXXFLAGS += -mmacosx-version-min=10.11
endif
     OBJS = agg_arc.o \
        agg_arrowhead.o \
        agg_bezier_arc.o \
        agg_bspline.o \
        agg_color_rgba.o \
        agg_curves.o \
        agg_embedded_raster_fonts.o \
        agg_gsv_text.o \
        agg_image_filters.o \
        agg_line_aa_basics.o \
        agg_line_profile_aa.o \
        agg_rounded_rect.o \
        agg_sqrt_tables.o \
        agg_trans_affine.o \
        agg_trans_double_path.o \
        agg_trans_single_path.o \
        agg_trans_warp_magnifier.o \
        agg_vcgen_bspline.o \
        agg_vcgen_contour.o \
        agg_vcgen_dash.o \
        agg_vcgen_markers_term.o \
        agg_vcgen_smooth_poly1.o \
        agg_vcgen_stroke.o \
        agg_vpgen_clip_polygon.o \
        agg_vpgen_clip_polyline.o \
        agg_vpgen_segmentator.o \

default: install

libagg.a: $(OBJS)
	$(AR) crv $@ $?
	$(AR) ts $@

distclean: clean

clean:
	rm -f libagg.a *.o

$(PREFIX)/lib/libagg.a: libagg.a
	mkdir -p $(PREFIX)/lib/
	mkdir -p $(PREFIX)/include/
	cp -p libagg.a $(PREFIX)/lib/
	cp -p include/*.h $(PREFIX)/include/

install: $(PREFIX)/lib/libagg.a

%.o: src/%.cpp
	$(CXX) -c $(CXXFLAGS) src/$*.cpp -o $@

=== 3rdparty/bzip2/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

  CFLAGS = -O -I. -fPIC -fno-common $(ARCHS)
ifndef OS
ifeq ($(shell uname),Darwin)
 CFLAGS += -mmacosx-version-min=10.15
endif
else ifeq ($(shell [[ "$(OS)" =~ [dD]"arwin" ]] && echo macos), macos)
 CFLAGS += -mmacosx-version-min=10.15
endif
    OBJS = blocksort.o \
        huffman.o \
        crctable.o \
        randtable.o \
        compress.o \
        decompress.o \
        bzlib.o

default: install

libbz2.a: $(OBJS)
	$(AR) crv $@ $?
	$(AR) ts $@

distclean: clean

clean:
	rm -f libbz2.a *.o *.bak

$(PREFIX)/lib/libbz2.a: libbz2.a
	mkdir -p $(PREFIX)/lib/
	mkdir -p $(PREFIX)/include/
	cp libbz2.a $(PREFIX)/lib/
	cp bzlib.h $(PREFIX)/include/

install: $(PREFIX)/lib/libbz2.a

depend:
	makedepend -Y -- \
        huffman.c \
        crctable.c \
        randtable.c \
        compress.c \
        decompress.c \
        bzlib.o 2> /dev/null

.PHONY: default install clean distclean depend

# DO NOT DELETE THIS LINE -- make depend depends on it.

huffman.o: bzlib_private.h bzlib.h
crctable.o: bzlib_private.h bzlib.h
randtable.o: bzlib_private.h bzlib.h
compress.o: bzlib_private.h bzlib.h
decompress.o: bzlib_private.h bzlib.h

=== 3rdparty/cairo/Makefile ===
SHELL := /bin/bash

ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

VERSION = 1.16.0
CAIRO_EXTRA_CONFIGURE_FLAGS ?=
ifndef OS
ifeq ($(shell uname),Darwin)
CAIRO_EXTRA_CONFIGURE_FLAGS  += CFLAGS=-mmacosx-version-min=10.15
endif
else ifeq ($(shell [[ "$(OS)" =~ [dD]"arwin" ]] && echo macos), macos)
CAIRO_EXTRA_CONFIGURE_FLAGS  += CFLAGS=-mmacosx-version-min=10.15
endif

CAIRO_EXTRA_CFLAGS ?=
ifeq ($(shell [[ "$(CC)" =~ -mingw ]] && echo mingw),mingw)
CAIRO_EXTRA_CFLAGS += -D_FORTIFY_SOURCE=0
endif

ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell curl --version 2>/dev/null),)
DOWNLOAD_CMD := curl -k -OL
endif
endif
ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell wget --version 2>/dev/null),)
DOWNLOAD_CMD := wget --no-check-certificate
endif
endif
ifeq ($(DOWNLOAD_CMD),)
DOWNLOAD_CMD := echo "Error: Unable to find curl or wget."; exit 1; \#
endif

default: install

$(PREFIX)/src/cairo-$(VERSION).tar.xz:
	mkdir -p $(PREFIX)/src
	cd $(PREFIX)/src/ && $(DOWNLOAD_CMD) https://gr-framework.org/downloads/3rdparty/cairo-$(VERSION).tar.xz

$(PREFIX)/src/cairo-$(VERSION)/configure: $(PREFIX)/src/cairo-$(VERSION).tar.xz
	cd $(PREFIX)/src/ && tar -xf cairo-$(VERSION).tar.xz
	touch $@

$(PREFIX)/src/cairo-$(VERSION)/Makefile: $(PREFIX)/src/cairo-$(VERSION)/configure $(PREFIX)/lib/libz.a $(PREFIX)/lib/libpng.a $(PREFIX)/lib/libfreetype.a $(PREFIX)/lib/libpixman-1.a
	cd $(PREFIX)/src/cairo-$(VERSION) && \
	export CFLAGS="-O -fPIC $(CAIRO_EXTRA_CFLAGS)" && \
	export LIBS=$(PREFIX)/lib/libz.a && \
	export png_REQUIRES=libpng16 && \
	export png_CFLAGS=-I$(PREFIX)/include && \
	export png_LIBS=$(PREFIX)/lib/libpng.a && \
	export png_NONPKGCONFIG_CFLAGS=-I$(PREFIX)/include && \
	export png_NONPKGCONFIG_LIBS=$(PREFIX)/lib/libpng.a && \
	export pixman_CFLAGS=-I$(PREFIX)/include/pixman-1 && \
	export pixman_LIBS=$(PREFIX)/lib/libpixman-1.a && \
	export FREETYPE_CFLAGS=-I$(PREFIX)/include/ && \
	export FREETYPE_LIBS=$(PREFIX)/lib/libfreetype.a && \
	export ARFLAGS="rcs" && \
	./configure \
		--prefix=$(PREFIX) \
		--libdir=$(PREFIX)/lib \
		--enable-static \
		--disable-shared \
		--with-pic \
		--disable-dependency-tracking \
		--disable-quartz \
		--enable-ft \
		--disable-fc \
		--disable-ps \
		--disable-pdf \
		--disable-svg \
		--disable-script \
		--disable-trace \
		--disable-interpreter \
		--disable-valgrind \
		--without-x \
		--disable-xlib \
		--disable-xlib-xrender \
		--disable-xcb \
		--disable-xlib-xcb \
		$(CAIRO_EXTRA_CONFIGURE_FLAGS)
	# Do not build tests or demos
	cp dummy.Makefile $(PREFIX)/src/cairo-$(VERSION)/test/Makefile
	cp dummy.Makefile $(PREFIX)/src/cairo-$(VERSION)/perf/Makefile
	# configure doesn't update the Makefile mtime correctly
	touch $@

$(PREFIX)/lib/libcairo.a: $(PREFIX)/src/cairo-$(VERSION)/Makefile
	export CFLAGS="-O -fPIC $(CAIRO_EXTRA_CFLAGS)" && \
	export LIBS=$(PREFIX)/lib/libz.a && \
	export png_REQUIRES=libpng16 && \
	export png_CFLAGS=-I$(PREFIX)/include && \
	export png_LIBS=$(PREFIX)/lib/libpng.a && \
	export png_NONPKGCONFIG_CFLAGS=-I$(PREFIX)/include && \
	export png_NONPKGCONFIG_LIBS=$(PREFIX)/lib/libpng.a && \
	export pixman_CFLAGS=-I$(PREFIX)/include/pixman-1 && \
	export pixman_LIBS=$(PREFIX)/lib/libpixman-1.a && \
	export FREETYPE_CFLAGS=-I$(PREFIX)/include/ && \
	export FREETYPE_LIBS=$(PREFIX)/lib/libfreetype.a && \
	$(MAKE) -C $(PREFIX)/src/cairo-$(VERSION) -j4 && \
	$(MAKE) -C $(PREFIX)/src/cairo-$(VERSION) install
	# Fix broken libcairo static library issues on some systems (e.g. Darwin)
	mkdir -p $(PREFIX)/build/cairo-$(VERSION)
	cd $(PREFIX)/build/cairo-$(VERSION) && $(AR) x $(PREFIX)/lib/libcairo.a
	cd $(PREFIX)/build/cairo-$(VERSION) && $(AR) crv libcairo.a *.o
	mv $(PREFIX)/build/cairo-$(VERSION)/libcairo.a $(PREFIX)/lib/libcairo.a

install: $(PREFIX)/lib/libcairo.a

$(PREFIX)/lib/libz.a:
	$(MAKE) -C ../zlib PREFIX="$(PREFIX)" install

$(PREFIX)/lib/libpng.a:
	$(MAKE) -C ../libpng16 PREFIX="$(PREFIX)" install

$(PREFIX)/lib/libfreetype.a:
	$(MAKE) -C ../freetype PREFIX="$(PREFIX)" install

$(PREFIX)/lib/libpixman-1.a:
	$(MAKE) -C ../pixman PREFIX="$(PREFIX)" install

.PHONY: default install

=== 3rdparty/freetype/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

 FTDEFINES = -DFT2_BUILD_LIBRARY -DDARWIN_NO_CARBON \
             '-DFT_CONFIG_MODULES_H="slimftmodules.h"' \
             '-DFT_CONFIG_OPTIONS_H="slimftoptions.h"'
FTINCLUDES = -Isrc -Iinclude
  FTCFLAGS = -O -fPIC -fno-common $(FTINCLUDES) $(FTDEFINES) $(ARCHS)

ifndef OS
ifeq ($(shell uname),Darwin)
 FTCFLAGS += -mmacosx-version-min=10.15
endif
else ifeq ($(shell [[ "$(OS)" =~ [dD]"arwin" ]] && echo macos), macos)
 FTCFLAGS += -mmacosx-version-min=10.15
endif

      OBJS = \
        ftbase.o \
        ftbbox.o \
        ftbitmap.o \
        ftdebug.o \
        ftgasp.o \
        ftglyph.o \
        ftinit.o \
        ftstroke.o \
        ftsynth.o \
        ftsystem.o \
        fttype1.o \
        ftmm.o \
        cff.o \
        psaux.o \
        pshinter.o \
        psnames.o \
        raster.o \
        sfnt.o \
        smooth.o \
        truetype.o \
        type1.o \
        type1cid.o

default: install

libfreetype.a: $(OBJS)
	$(AR) crv $@ $?
	$(AR) ts $@

%.o: src/base/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/cff/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/cid/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/psaux/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/pshinter/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/psnames/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/raster/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/smooth/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/sfnt/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/truetype/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<
%.o: src/type1/%.c
	$(CC) $(FTCFLAGS) -o $@ -c $<

distclean: clean

clean:
	rm -f libfreetype.a *.o

$(PREFIX)/lib/libfreetype.a: libfreetype.a
	mkdir -p $(PREFIX)/lib/
	mkdir -p $(PREFIX)/include/
	cp libfreetype.a $(PREFIX)/lib/
	cp include/ft2build.h $(PREFIX)/include/
	cp -r include/freetype $(PREFIX)/include/

install: $(PREFIX)/lib/libfreetype.a

.PHONY: default install clean distclean

=== 3rdparty/glfw/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

VERSION = 3.3.3
GLFW_EXTRA_CMAKE_FLAGS ?=
ifeq ($(shell uname),Darwin)
 GLFW_EXTRA_CMAKE_FLAGS += -DCMAKE_OSX_DEPLOYMENT_TARGET=10.15
endif

ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell curl --version 2>/dev/null),)
DOWNLOAD_CMD := curl -k -OL
endif
endif
ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell wget --version 2>/dev/null),)
DOWNLOAD_CMD := wget --no-check-certificate
endif
endif
ifeq ($(DOWNLOAD_CMD),)
DOWNLOAD_CMD := echo "Error: Unable to find curl or wget."; exit 1; \#
endif

ifeq ($(CMAKE_CMD),)
ifneq ($(shell cmake --version 2>/dev/null),)
CMAKE_CMD := cmake
CMAKE_DEP :=
endif
endif
ifeq ($(CMAKE_CMD),)
CMAKE_CMD := $(PREFIX)/bin/cmake
CMAKE_DEP := $(CMAKE_CMD)
endif

default: install

$(PREFIX)/src/glfw-$(VERSION).tar.gz:
	mkdir -p $(PREFIX)/src
	cd $(PREFIX)/src/ && $(DOWNLOAD_CMD) https://gr-framework.org/downloads/3rdparty/glfw-$(VERSION).tar.gz

$(PREFIX)/src/glfw-$(VERSION)/CMakeLists.txt: $(PREFIX)/src/glfw-$(VERSION).tar.gz
	cd $(PREFIX)/src/ && tar -xf glfw-$(VERSION).tar.gz
	cd $(PREFIX)/src/glfw-$(VERSION) && \
	( \
	echo '--- a/CMakeLists.txt'; \
	echo '+++ b/CMakeLists.txt'; \
	echo '@@ -1,4 +1,4 @@'; \
	echo '-cmake_minimum_required(VERSION 3.0)'; \
	echo '+cmake_minimum_required(VERSION 3.5)'; \
	echo; \
	echo ' project(GLFW VERSION 3.3.3 LANGUAGES C)'; \
	echo; \
	) | patch -Np1

$(PREFIX)/build/glfw-$(VERSION)/Makefile: $(PREFIX)/src/glfw-$(VERSION)/CMakeLists.txt $(CMAKE_DEP)
	mkdir -p $(PREFIX)/build/glfw-$(VERSION)
	cd $(PREFIX)/build/glfw-$(VERSION) && \
	$(CMAKE_CMD) \
		-DCMAKE_INSTALL_PREFIX:PATH=${PREFIX} \
		-DCMAKE_INSTALL_LIBDIR=lib \
		-DGLFW_USE_RETINA=OFF \
		-DGLFW_BUILD_EXAMPLES=OFF \
		-DGLFW_BUILD_DOCS=OFF \
		-DGLFW_BUILD_TESTS=OFF \
		$(GLFW_EXTRA_CMAKE_FLAGS) \
		$(PREFIX)/src/glfw-$(VERSION)/

$(PREFIX)/lib/libglfw3.a: $(PREFIX)/build/glfw-$(VERSION)/Makefile
	$(MAKE) -C $(PREFIX)/build/glfw-$(VERSION) -j4
	$(MAKE) -C $(PREFIX)/build/glfw-$(VERSION) install

install: $(PREFIX)/lib/libglfw3.a

.PHONY: default install

=== 3rdparty/icu/Makefile ===
SHELL := /bin/bash

ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

VERSION = 74.2
ICU_EXTRA_CONFIGURE_FLAGS ?=
ifndef OS
ifeq ($(shell uname),Darwin)
ICU_EXTRA_CONFIGURE_FLAGS += CFLAGS=-mmacosx-version-min=10.15
ICU_EXTRA_CONFIGURE_FLAGS += CXXFLAGS=-mmacosx-version-min=10.15
endif
else ifeq ($(shell [[ "$(OS)" =~ [dD]"arwin" ]] && echo macos), macos)
ICU_EXTRA_CONFIGURE_FLAGS += CFLAGS=-mmacosx-version-min=10.15
ICU_EXTRA_CONFIGURE_FLAGS += CXXFLAGS=-mmacosx-version-min=10.15
endif

ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell curl --version 2>/dev/null),)
DOWNLOAD_CMD := curl -f -k -OL
endif
endif
ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell wget --version 2>/dev/null),)
DOWNLOAD_CMD := wget --no-check-certificate
endif
endif
ifeq ($(DOWNLOAD_CMD),)
DOWNLOAD_CMD := echo "Error: Unable to find curl or wget."; exit 1; \#
endif

ifeq ($(shell [[ "$(ARCH)" == "x86_64" || "$(ARCHS)" == "-arch x86_64" ]] && echo macos_cross),macos_cross)
default: run_macos_x86_64_cross_makefile
else ifeq ($(shell [[ "$(CC)" =~ -mingw ]] && echo mingw),mingw)
default: run_mingw_makefile
else
default: install
endif

run_macos_x86_64_cross_makefile:
	$(MAKE) -f Makefile.macos_x86_64_cross

run_mingw_makefile:
	$(MAKE) -f Makefile.mingw

$(PREFIX)/src/icu4c-$(VERSION).tar.gz:
	mkdir -p $(PREFIX)/src
	cd $(PREFIX)/src/ && $(DOWNLOAD_CMD) https://gr-framework.org/downloads/3rdparty/icu4c-$(VERSION).tar.gz

$(PREFIX)/src/icu/source/configure: $(PREFIX)/src/icu4c-$(VERSION).tar.gz
	cd $(PREFIX)/src/ && tar -xf icu4c-$(VERSION).tar.gz

$(PREFIX)/src/icu/source/Makefile: $(PREFIX)/src/icu/source/configure
	cd $(PREFIX)/src/icu/source && \
	CFLAGS="-fPIC" \
	CXXFLAGS="-fPIC" \
	./configure \
		--prefix=$(PREFIX) \
		--enable-static \
		--disable-shared \
		$(ICU_EXTRA_CONFIGURE_FLAGS)
	touch $@

$(PREFIX)/lib/libicuuc.a: $(PREFIX)/src/icu/source/Makefile
	$(MAKE) -C $(PREFIX)/src/icu/source -j4
	$(MAKE) -C $(PREFIX)/src/icu/source install

libicuuc.a: $(PREFIX)/lib/libicuuc.a
	cp $(PREFIX)/lib/libicuuc.a libicuuc.a
	cp $(PREFIX)/lib/libicudata.a libicudata.a

clean:
	rm -f libicuuc.a
	rm -f libicudata.a

install: $(PREFIX)/lib/libicuuc.a

.PHONY: default clean install run_macos_x86_64_cross_makefile run_mingw_makefile

=== 3rdparty/jpeg/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

  CFLAGS = -O -I. -fPIC -fno-common $(ARCHS)
ifndef OS
 ifeq ($(shell uname),Darwin)
  ifneq ($(notdir $(CC)),emcc)
   CFLAGS += -mmacosx-version-min=10.15
  endif
 endif
else ifeq ($(shell [[ "$(OS)" =~ [dD]"arwin" ]] && echo macos), macos)
 ifneq ($(notdir $(CC)),emcc)
  CFLAGS += -mmacosx-version-min=10.15
 endif
endif
    OBJS = \
        jaricom.o \
        jcapimin.o \
        jcapistd.o \
        jcarith.o \
        jccoefct.o \
        jccolor.o \
        jcdctmgr.o \
        jchuff.o \
        jcinit.o \
        jcmainct.o \
        jcmarker.o \
        jcmaster.o \
        jcomapi.o \
        jcparam.o \
        jcprepct.o \
        jcsample.o \
        jctrans.o \
        jdapimin.o \
        jdapistd.o \
        jdarith.o \
        jdatadst.o \
        jdatasrc.o \
        jdcoefct.o \
        jdcolor.o \
        jddctmgr.o \
        jdhuff.o \
        jdinput.o \
        jdmainct.o \
        jdmarker.o \
        jdmaster.o \
        jdmerge.o \
        jdpostct.o \
        jdsample.o \
        jdtrans.o \
        jerror.o \
        jfdctflt.o \
        jfdctfst.o \
        jfdctint.o \
        jidctflt.o \
        jidctfst.o \
        jidctint.o \
        jmemmgr.o \
        jmemnobs.o \
        jquant1.o \
        jquant2.o \
        jutils.o

default: install

libjpeg.a: $(OBJS)
	$(AR) crv $@ $?
	$(AR) ts $@

distclean: clean

clean:
	rm -f libjpeg.a *.o *.bak

$(PREFIX)/lib/libjpeg.a: libjpeg.a
	mkdir -p $(PREFIX)/lib/
	mkdir -p $(PREFIX)/include/
	cp libjpeg.a $(PREFIX)/lib/
	cp *.h $(PREFIX)/include/

install: $(PREFIX)/lib/libjpeg.a

depend:
	makedepend -Y -- \
        jaricom.c \
        jcapimin.c \
        jcapistd.c \
        jcarith.c \
        jccoefct.c \
        jccolor.c \
        jcdctmgr.c \
        jchuff.c \
        jcinit.c \
        jcmainct.c \
        jcmarker.c \
        jcmaster.c \
        jcomapi.c \
        jcparam.c \
        jcprepct.c \
        jcsample.c \
        jctrans.c \
        jdapimin.c \
        jdapistd.c \
        jdarith.c \
        jdatadst.c \
        jdatasrc.c \
        jdcoefct.c \
        jdcolor.c \
        jddctmgr.c \
        jdhuff.c \
        jdinput.c \
        jdmainct.c \
        jdmarker.c \
        jdmaster.c \
        jdmerge.c \
        jdpostct.c \
        jdsample.c \
        jdtrans.c \
        jerror.c \
        jfdctflt.c \
        jfdctfst.c \
        jfdctint.c \
        jidctflt.c \
        jidctfst.c \
        jidctint.c \
        jmemmgr.c \
        jmemnobs.c \
        jquant1.c \
        jquant2.c \
        jutils.c 2> /dev/null

.PHONY: default install clean distclean depend

# DO NOT DELETE THIS LINE -- make depend depends on it.

jaricom.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcapimin.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcapistd.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcarith.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jccoefct.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jccolor.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcdctmgr.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jdct.h
jchuff.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcinit.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcmainct.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcmarker.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcmaster.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcomapi.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcparam.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcprepct.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jcsample.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jctrans.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdapimin.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdapistd.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdarith.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdatadst.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdatasrc.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdcoefct.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdcolor.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jddctmgr.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jdct.h
jdhuff.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdinput.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdmainct.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdmarker.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdmaster.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdmerge.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdpostct.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdsample.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jdtrans.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jerror.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jversion.h
jfdctflt.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jdct.h
jfdctfst.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jdct.h
jfdctint.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jdct.h
jidctflt.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jdct.h
jidctfst.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jdct.h
jidctint.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jdct.h
jmemmgr.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jmemsys.h
jmemnobs.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h jmemsys.h
jquant1.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jquant2.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h
jutils.o: jinclude.h jpeglib.h jmorecfg.h jpegint.h jerror.h

=== 3rdparty/libpng16/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

 PNGCFLAGS = -O -I. -I../zlib/ -fPIC -fno-common $(PNG_EXTRA_CFLAGS) $(ARCHS)
ifeq ($(notdir $(CC)), emcc)
else ifndef OS
 ifeq ($(shell uname),Darwin)
  PNGCFLAGS += -mmacosx-version-min=10.15
  ifeq ($(shell arch),arm64)
   PNGCFLAGS += -DPNG_ARM_NEON_OPT=0
  endif
 else ifeq ($(shell arch),aarch64)
  PNGCFLAGS += -DPNG_ARM_NEON_OPT=0
 endif
else ifeq ($(shell [[ "$(OS)" =~ [dD]"arwin" ]] && echo macos), macos)
 PNGCFLAGS += -mmacosx-version-min=10.15
 ifeq ($(shell arch),arm64)
  PNGCFLAGS += -DPNG_ARM_NEON_OPT=0
 endif
else ifeq ($(shell [[ "$(OS)" =~ "aarch64" ]] && echo aarch64), aarch64)
 PNGCFLAGS += -DPNG_ARM_NEON_OPT=0
endif
      OBJS = \
	png.o \
	pngerror.o \
	pngget.o \
	pngmem.o \
	pngpread.o \
	pngread.o \
	pngrio.o \
	pngrtran.o \
	pngrutil.o \
	pngset.o \
	pngtrans.o \
	pngwio.o \
	pngwrite.o \
	pngwtran.o \
	pngwutil.o

.c.o:
	$(CC) $(PNGCFLAGS) -o $@ -c $<

default: install

libpng.a: $(OBJS)
	$(AR) crv $@ $?
	$(AR) ts $@

distclean: clean

clean:
	rm -f libpng.a *.o *.bak

depend:
	makedepend -Y -- \
	png.c \
	pngerror.c \
	pngget.c \
	pngmem.c \
	pngpread.c \
	pngread.c \
	pngrio.c \
	pngrtran.c \
	pngrutil.c \
	pngset.c \
	pngtrans.c \
	pngwio.c \
	pngwrite.c \
	pngwtran.c \
	pngwutil.c

$(PREFIX)/lib/libpng.a: libpng.a
	mkdir -p $(PREFIX)/lib/
	mkdir -p $(PREFIX)/include/
	cp libpng.a $(PREFIX)/lib/
	cp *.h $(PREFIX)/include/

install: $(PREFIX)/lib/libpng.a

.PHONY: default install clean distclean depend

# DO NOT DELETE THIS LINE -- make depend depends on it.

png.o: png.h
pngerror.o: png.h
pngget.o: png.h
pngmem.o: png.h
pngpread.o: png.h
pngread.o: png.h
pngrio.o: png.h
pngrtran.o: png.h
pngrutil.o: png.h
pngset.o: png.h
pngtrans.o: png.h
pngwio.o: png.h
pngwrite.o: png.h
pngwtran.o: png.h
pngwutil.o: png.h

=== 3rdparty/ogg/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

VERSION = 1.3.2
OGG_EXTRA_CONFIGURE_FLAGS ?=
ifndef OS
ifeq ($(shell uname),Darwin)
OGG_EXTRA_CONFIGURE_FLAGS += CFLAGS=-mmacosx-version-min=10.15
endif
else ifeq ($(shell [[ "$(OS)" =~ [dD]"arwin" ]] && echo macos), macos)
OGG_EXTRA_CONFIGURE_FLAGS += CFLAGS=-mmacosx-version-min=10.15
endif

ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell curl --version 2>/dev/null),)
DOWNLOAD_CMD := curl -k -OL
endif
endif
ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell wget --version 2>/dev/null),)
DOWNLOAD_CMD := wget --no-check-certificate
endif
endif
ifeq ($(DOWNLOAD_CMD),)
DOWNLOAD_CMD := echo "Error: Unable to find curl or wget."; exit 1; \#
endif

default: install

$(PREFIX)/src/libogg-$(VERSION).tar.gz:
	mkdir -p $(PREFIX)/src
	cd $(PREFIX)/src/ && $(DOWNLOAD_CMD) https://gr-framework.org/downloads/3rdparty/libogg-$(VERSION).tar.gz

$(PREFIX)/src/libogg-$(VERSION)/configure: $(PREFIX)/src/libogg-$(VERSION).tar.gz
	cd $(PREFIX)/src/ && tar -xf libogg-$(VERSION).tar.gz
	touch $@

$(PREFIX)/src/libogg-$(VERSION)/Makefile: $(PREFIX)/src/libogg-$(VERSION)/configure
	cd $(PREFIX)/src/libogg-$(VERSION) && \
	./configure \
		--prefix=$(PREFIX) \
		--libdir=$(PREFIX)/lib \
		--enable-static \
		--disable-shared \
		--with-pic \
		--disable-dependency-tracking \
		$(OGG_EXTRA_CONFIGURE_FLAGS)

$(PREFIX)/lib/libogg.a: $(PREFIX)/src/libogg-$(VERSION)/Makefile
	$(MAKE) -C $(PREFIX)/src/libogg-$(VERSION) -j4
	$(MAKE) -C $(PREFIX)/src/libogg-$(VERSION) install

install: $(PREFIX)/lib/libogg.a

.PHONY: default install

=== PKGBUILD ===
# Maintainer: Sutou Kouhei <kou@clear-code.com>

_realname=gr
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=0.73.18
pkgrel=1
pkgdesc="A graphics library for visualisation applications (mingw-w64)"
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://gr-framework.org/"
msys2_repository_url="https://github.com/sciapp/gr"
msys2_references=(
  'aur: gr-framework'
  'gentoo: sci-visualization/gr'
)
license=("spdx:MIT")
depends=("${MINGW_PACKAGE_PREFIX}-bzip2"
         "${MINGW_PACKAGE_PREFIX}-cairo"
         "${MINGW_PACKAGE_PREFIX}-ffmpeg"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-fontconfig"
         "${MINGW_PACKAGE_PREFIX}-glfw"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-qhull"
         "${MINGW_PACKAGE_PREFIX}-qt5-base"
         "${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-zlib"
         "${MINGW_PACKAGE_PREFIX}-zeromq")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://github.com/sciapp/gr/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "0002-missing-cmake-dep.patch")
sha256sums=('0821ce71be438b09fdf4a62c567197ce5b35a0ab1e9c925d2817f0ff1ff67294'
            'a57fc0c01f8c3a241cb01ac293034a2e28f631264d506c6988ccd1f3a7f54c79')
noextract=("${_realname}-${pkgver}.tar.gz")

prepare() {
  # We can't use bsdtar to extract the archive because the archive includes
  # symbolic link.
  rm -rf "${_realname}-${pkgver}"
  tar -xf "${_realname}-${pkgver}.tar.gz" || true

  cd "${srcdir}/${_realname}-${pkgver}"

  patch -p1 < "${srcdir}/0002-missing-cmake-dep.patch"

  # Set version manually, otherwise it resets to zero
  echo "${pkgver}" > version.txt
  sed -i "s|\${GR_VERSION}|${pkgver}|g" CMakeLists.txt
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
    -G "Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DGR_USE_BUNDLED_LIBRARIES=OFF \
    "${_extra_config[@]}" \
    ../${_realname}-${pkgver}

  cmake --build ./
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE.md "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE.md"
}
